package ru.pif.mobile.android.speech;

import java.util.ArrayList;

import ru.pif.mobile.android.ContextExt;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.speech.RecognizerIntent;

public class SpeechHandler extends Activity {

	public static Intent speechIntent;
	private static final int VOICE_RECOGNITION_REQUEST_CODE = 343222;

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 * 
	 * Called when the activity is first created
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		startActivityForResult(speechIntent, VOICE_RECOGNITION_REQUEST_CODE);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onActivityResult(int, int,
	 * android.content.Intent)
	 * 
	 * -> Listen for results from native speech utility -> Dispatch events
	 * (dispatchStatusEventAsync) containing appropriate results. The library
	 * listens for these events.
	 */
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == VOICE_RECOGNITION_REQUEST_CODE && resultCode == RESULT_OK) {
			ArrayList<String> matches = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS); 
			String rez = "";
			for (int i = 0; i < matches.size(); i++) {
				if (i != 0)
					rez += ",";
				rez += matches.get(i);
			}

			ContextExt.activite.dispatchStatusEventAsync("VOICE_RECOGNIZED", rez);
			finish();
		} else {
			ContextExt.activite.dispatchStatusEventAsync("VOICE_NOT_RECOGNIZED",""+resultCode);
			finish();
		}

		super.onActivityResult(requestCode, resultCode, data);
	}
}
