/*
Copyright (c) 2012 http://www.immanuelnoel.com

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software or code, hereby referred to as 'Software' and associated documentation 
files (the "Software"), to deal in the Software without restriction, including 
without limitation the rights to use, copy, modify, merge, publish, distribute, 
sublicense, and/or sell copies of the Software, and to permit persons to whom the 
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

package com.inoel.ane.speech.extensions;

import android.content.Intent;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;

public class SpeechListen implements FREFunction  {
	
	public static SpeechExtensionContext speechContext;
	
	/* (non-Javadoc)
	 * @see com.adobe.fre.FREFunction#call(com.adobe.fre.FREContext, com.adobe.fre.FREObject[])
	 *
	 * Launch's a new activity to bring up the native Speech Input UI
	 * Reasoning: The 'onActivityResult' method, that needs to be overridden to catch output generated by the native speech utility, cannot be written within a class that implements FREFunction. 
	 *            To overcome this restriction, launch a new activity and listen for 'onActivityResult' within that ! 
	 */
	@Override
	public FREObject call(FREContext context, FREObject[] args) {
		
		speechContext = (SpeechExtensionContext)context;
		
		Intent in = new Intent(speechContext.getActivity(), SpeechHandler.class);
		speechContext.getActivity().startActivity(in); // Fire a new (SpeechHandler) activity which in-turn launch's the Speech Native UI
		
		return null;
	}
}																																																																																																																																																																																																																																																																																																																																